datablock AudioProfile(GoldenEyeEquipSound)
{
   filename    			= "./ge_equip.wav";
   description			= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(gePC9FireSound)
{
   filename    			= "./ge_pc9_fire.wav";
   description 			= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(GoldenEyeReload1Sound)
{
   filename    			= "./ge_reload1.wav";
   description 			= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(GoldenEyeReload2Sound)
{
   filename    			= "./ge_reload2.wav";
   description 			= AudioClose3d;
   preload 				= true;
}; 
datablock AudioProfile(GoldenEyeRicSound1)
{
   filename    			= "./ge_ric1.wav";
   description 			= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(GoldenEyeRicSound2)
{
   filename    			= "./ge_ric2.wav";
   description 			= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(GoldenEyeRicSound3)
{
   filename    			= "./ge_ric3.wav";
   description		 	= AudioClose3d;
   preload 				= true;
};
datablock AudioProfile(GoldenEyeRicSound4)
{
   filename    			= "./ge_ric4.wav";
   description 			= AudioClose3d;
   preload 				= true;
};
datablock DebrisData(GoldenEyeCasing)
{
	shapeFile 			= "./brass.dts";
	lifetime 			= 10.0;
	minSpinSpeed 		= -1000.0;
	maxSpinSpeed 		= 1000.0;
	elasticity 			= 0.5;
	friction 			= 0.1;
	numBounces 			= 3;
	staticOnMaxBounce 	= true;
	snapOnMaxBounce 	= false;
	fade 				= true;

	gravModifier 		= 4;
};
datablock ParticleData(GoldenEyeFlashParticle)
{
	dragCoefficient     = 3;
	gravityCoefficient  = -0.5;
	inheritedVelFactor  = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS          = 25;
	lifetimeVarianceMS  = 15;
	textureName         = "./ge_muzzleflash";
	spinSpeed			= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	
	colors[0]     		= "1.0 1.0 1.0 0.5";
	colors[1]     		= "1.0 1.0 1.0 0.0";
	
	sizes[0]      		= 1.0;
	sizes[1]      		= 0.7;

	useInvAlpha 		= false;
};
datablock ParticleEmitterData(GoldenEyeFlashEmitter)
{
   ejectionPeriodMS 	= 3;
   periodVarianceMS 	= 0;
   ejectionVelocity 	= 1.0;
   velocityVariance 	= 1.0;
   ejectionOffset   	= 0.0;
   thetaMin         	= 0;
   thetaMax         	= 90;
   phiReferenceVel  	= 0;
   phiVariance      	= 360;
   overrideAdvance 		= false;
   particles 			= "GoldenEyeFlashParticle";

   uiName 				= "Goldeneye Muzzle Flash";
};
datablock ExplosionData(gePC9Explosion)
{
	soundProfile 		= "";

	lifeTimeMS 			= 150;

	particleEmitter 	= gunExplosionEmitter;
	particleDensity 	= 5;
	particleRadius 		= 0.2;

	emitter[0] 			= gunExplosionRingEmitter;

	faceViewer     		= true;
	explosionScale 		= "1 1 1";

	shakeCamera 		= false;
	camShakeFreq 		= "10.0 11.0 10.0";
	camShakeAmp 		= "1.0 1.0 1.0";
	camShakeDuration 	= 0.5;
	camShakeRadius 		= 10.0;

	// Dynamic light
	lightStartRadius 	= 0;
	lightEndRadius 		= 2;
	lightStartColor 	= "0.7 0.6 0.3";
	lightEndColor 		= "0 0 0";
};
AddDamageType("gePC9",   '<bitmap:add-ons/Weapon_GE-PC9/pc9_CI> %1',    '%2 <bitmap:add-ons/Weapon_GE-PC9/pc9_CI> %1',0.2,1);
datablock ProjectileData(gePC9Projectile)
{
   projectileShapeName 	= "add-ons/Weapon_Gun/bullet.dts";
   directDamage        	= 15;
   directDamageType    	= $DamageType::gePC9;
   radiusDamageType    	= $DamageType::gePC9;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	    = 0;
   verticalImpulse	  	= 0;
   explosion           	= gunExplosion;
   particleEmitter     	= bulletTrailEmitter;

   muzzleVelocity      	= 250;
   velInheritFactor    	= 1;

   armingDelay         	= 00;
   lifetime            	= 4000;
   fadeDelay           	= 3500;
   bounceElasticity    	= 0.5;
   bounceFriction      	= 0.20;
   isBallistic         	= false;
   gravityMod 			= 0.0;

   hasLight    			= false;
   lightRadius 			= 3.0;
   lightColor  			= "0 0 0.5";

   uiName 				= "Goldeneye PC9 Bullet";
};

//////////
// item //
//////////
datablock ItemData(gePC9Item)
{
	category 			= "Weapon";  // Mission editor category
	className 			= "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile 			= "./pc9.dts";
	rotate 				= false;
	mass 				= 1;
	density 			= 0.2;
	elasticity 			= 0.2;
	friction 			= 0.6;
	emap 				= true;

	//gui stuff
	uiName 				= "Goldeneye PC9";
	iconName 			= "./pc9_icon";
	doColorShift 		= false;

	// Dynamic properties defined by the scripts
	image 				= gePC9Image;
	canDrop 			= true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(gePC9Image)
{
	// Basic Item properties
	shapeFile 			= "./pc9.dts";
	emap 				= true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint 			= 0;
	offset 				= "0 0 0";
	eyeOffset 			= 0; //"0.7 1.2 -0.5";
	rotation 			= eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className 			= "WeaponImage";

	// Projectile && Ammo.
	item 				= gePC9Item;
	ammo 				= " ";
	projectile 			= gePC9Projectile;
	projectileType 		= Projectile;

	casing 				= GoldenEyeCasing;
	shellExitDir        = "0.75 -0.25 1.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 10.0;

	//melee particles shoot from eye node for consistancy
	melee 				= false;
	//raise your arm up or not
	armReady 			= true;

	doColorShift 		= false;
	
	// Images have a state system which controls how the animations
	// are run, which sounds are played, script callbacks, etc. This
	// state system is downloaded to the client so that clients can
	// predict state changes and animate accordingly.  The following
	// system supports basic ready->fire->reload transitions as
	// well as a no-ammo->dryfire idle state.
   
	// Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.25;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]						= GoldenEyeEquipSound;

	stateName[1]						= "LoadCheckA";
	stateScript[1]						= "onLoadCheck";
	stateTransitionOnTimeout[1]			= "LoadCheckB";

	stateName[2]						= "LoadCheckB";
	stateTransitionOnAmmo[2]			= "Ready";
	stateTransitionOnNoAmmo[2]			= "Reload";

	stateName[3]                     	= "Ready";
	stateTransitionOnTriggerDown[3]  	= "FireLoadCheckA";
	stateAllowImageChange[3]         	= true;
	stateSequence[3]					= "Ready";

	stateName[4]                    	= "Fire";
	stateTransitionOnTimeout[4]     	= "f_Reload";
	stateTimeoutValue[4]            	= 0.065;
	stateFire[4]                    	= true;
	stateAllowImageChange[4]        	= false;
	stateSequence[4]               	 	= "Fire";
	stateScript[4]                  	= "onFire";
	stateWaitForTimeout[4]				= true;
	stateEmitter[4]						= GoldenEyeFlashEmitter;
	stateEmitterTime[4]					= 0.05;
	stateEjectShell[4]       	  		= true;
	stateEmitterNode[4]					= "muzzleNode";
	stateSound[4]						= gePC9FireSound;
	stateEjectShell[4]       			= true;

	stateName[6]						= "FireLoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTransitionOnTimeout[6]			= "FireLoadCheckB";

	stateName[7]						= "FireLoadCheckB";
	stateTransitionOnAmmo[7]			= "Fire";
	stateTransitionOnNoAmmo[7]			= "Reload";
	
	stateName[8]						= "f_Reload";
	stateAllowImageChange[8]        	= false;
	stateTransitionOnTimeout[8]     	= "f_Check";

	stateName[9]						= "f_Check";
	stateTransitionOnTriggerUp[9]		= "f_StopFire";
	stateTransitionOnTriggerDown[9]		= "Ready";
	
	stateName[10]                    	= "f_StopFire";
	stateTransitionOnTimeout[10]     	= "Ready";
	stateTimeoutValue[10]            	= 0.01;
	stateAllowImageChange[10]        	= false;
	stateWaitForTimeout[10]		    	= true;
	
	stateName[11]						= "Reload";
	stateSound[11]						= GoldenEyeReload1Sound;
	stateTimeoutValue[11]				= 0.35;
	stateScript[11]						= "onReloadStart";
	stateTransitionOnTimeout[11]		= "Reload2";
	stateWaitForTimeout[11]				= true;
	stateSequence[11]					= "Reload";

	
	stateName[12]						= "Reload2";
	stateSound[12]                   	= GoldenEyeReload2Sound;
	stateTransitionOnTimeout[12]		= "Reloaded";
	stateSequence[12]					= "Reload";

	stateName[13]						= "Reloaded";
	stateTimeoutValue[13]				= 0.35;
	stateTransitionOnTimeout[13]		= "Ready";
	stateScript[13]						= "onReloaded";
	stateSequence[13]					= "Ready";
};
function gePC9Projectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	serverplay3d("GoldenEyeRicSound" @ getRandom(1, 4), %obj.getTransform());
}
function gePC9Image::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%obj.playThread(2, plant);

	%obj.toolAmmo[%obj.currTool]--;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ "", 4, 2, 3, 4); 

	%projectile = %this.projectile;
	%spread = 0.0035;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function auxm29oicwImage::onReloadUp(%this,%obj,%slot)
{
	%obj.playThread(2, shiftUp);
}
function gePC9Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <=0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function gePC9Image::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, shiftDown);
}
function gePC9Image::onReloaded(%this,%obj,%slot)
{
	%obj.playThread(2, activate);
	%obj.toolAmmo[%obj.currTool] = 25;
	commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ "", 4, 2, 3, 4); 
	%obj.setImageAmmo(%slot,1);
}